;;; isol2-insert.el --- insert functions for ISO 8859/2.

;; Experiments towards the standard Czech keyboard.
;; The characters from the U.S. keyboard are accessible with the Alt key.
;; Modified by: Daniel Zeman, 7.7.1998

;; Dead keys changed to = and +; ` and 1 eliminated; [ and ; used instead.
;; Modified by: Jan Haji, 23.1.1994

;; Author: Ladislav Lhotka
;; Keywords: i18n

;; Commentary:

;; For each overrided key, there is a function that inserts the new character.
;; The key (resp. the original character) is then redirected to that function.
;; It must be done in this two-way manner so cyclic dependencies are avoided
;; and repeated request for keyboard redefinition does not destroy the previous
;; redefinition.

;; See case-table.el for details.

;; Code:

(defun insert-exclamation ()
   (interactive "*")
   (insert 33)
)

(defun insert-channel ()
   (interactive "*")
   (insert 35)
)

(defun insert-dollar ()
   (interactive "*")
   (insert 36)
)

(defun insert-percent ()
   (interactive "*")
   (insert 37)
)

(defun insert-commercial-at ()
   (interactive "*")
   (insert 38)
)

(defun insert-lparen ()
   (interactive "*")
   (insert 40)
)

(defun insert-rparen ()
   (interactive "*")
   (insert 41)
)

(defun insert-asterisk ()
   (interactive "*")
   (insert 42)
)

(defun insert-plus ()
   (interactive "*")
   (insert 43)
)

(defun insert-hyphen ()
   (interactive "*")
   (insert 45)
)

(defun insert-slash ()
   (interactive "*")
   (insert 47)
)

(defun insert-zero ()
   (interactive "*")
   (insert 48)
)

(defun insert-one ()
   (interactive "*")
   (insert 49)
)

(defun insert-two ()
   (interactive "*")
   (insert 50)
)

(defun insert-three ()
   (interactive "*")
   (insert 51)
)

(defun insert-four ()
   (interactive "*")
   (insert 52)
)

(defun insert-five ()
   (interactive "*")
   (insert 53)
)

(defun insert-six ()
   (interactive "*")
   (insert 54)
)

(defun insert-seven ()
   (interactive "*")
   (insert 55)
)

(defun insert-eight ()
   (interactive "*")
   (insert 56)
)

(defun insert-nine ()
   (interactive "*")
   (insert 57)
)

(defun insert-colon ()
   (interactive "*")
   (insert 58)
)

(defun insert-semicolon ()
   (interactive "*")
   (insert 59)
)

(defun insert-less-than ()
   (interactive "*")
   (insert 60)
)

(defun insert-equal-to ()
   (interactive "*")
   (insert 61)
)

(defun insert-greater-than ()
   (interactive "*")
   (insert 62)
)

(defun insert-question ()
   (interactive "*")
   (insert 63)
)

(defun insert-at ()
   (interactive "*")
   (insert 64)
)

(defun insert-Y ()
   (interactive "*")
   (insert 89)
)

(defun insert-Z ()
   (interactive "*")
   (insert 90)
)

(defun insert-lbracket ()
   (interactive "*")
   (insert 91)
)

(defun insert-backslash ()
   (interactive "*")
   (insert 92)
)

(defun insert-rbracket ()
   (interactive "*")
   (insert 93)
)

(defun insert-circumflex ()
   (interactive "*")
   (insert 94)
)

(defun insert-underscore ()
   (interactive "*")
   (insert 95)
)

(defun insert-reverse-single-quote ()
   (interactive "*")
   (insert 96)
)

(defun insert-y ()
   (interactive "*")
   (insert 121)
)

(defun insert-z ()
   (interactive "*")
   (insert 122)
)

(defun insert-lbrace ()
   (interactive "*")
   (insert 123)
)

(defun insert-vertical-bar ()
   (interactive "*")
   (insert 124)
)

(defun insert-rbrace ()
   (interactive "*")
   (insert 125)
)

(defun insert-no-break-space ()
   (interactive "*")
   (insert 160)
)

(defun insert-A-ogonek ()
   (interactive "*")
   (insert 161)
)

(defun insert-breve ()
   (interactive "*")
   (insert 162)
)

(defun insert-L-stroke ()
   (interactive "*")
   (insert 163)
)

(defun insert-currency-sign ()
   (interactive "*")
   (insert 164)
)

(defun insert-L-caron ()
   (interactive "*")
   (insert 165)
)

(defun insert-S-acute ()
   (interactive "*")
   (insert 166)
)

(defun insert-paragraph-sign ()
   (interactive "*")
   (insert 167)
)

(defun insert-diaeresis ()
   (interactive "*")
   (insert 168)
)

(defun insert-S-caron ()
   (interactive "*")
   (insert 169)
)

(defun insert-S-cedilla ()
   (interactive "*")
   (insert 170)
)

(defun insert-T-caron ()
   (interactive "*")
   (insert 171)
)

(defun insert-Z-acute ()
   (interactive "*")
   (insert 172)
)

(defun insert-soft-hyphen ()
   (interactive "*")
   (insert 173)
)

(defun insert-Z-caron ()
   (interactive "*")
   (insert 174)
)

(defun insert-Z-dot-above ()
   (interactive "*")
   (insert 175)
)

(defun insert-degree-sign ()
   (interactive "*")
   (insert 176)
)

(defun insert-a-ogonek ()
   (interactive "*")
   (insert 177)
)

(defun insert-ogonek ()
   (interactive "*")
   (insert 178)
)

(defun insert-l-stroke ()
   (interactive "*")
   (insert 179)
)

(defun insert-acute ()
   (interactive "*")
   (insert 180)
)

(defun insert-l-caron ()
   (interactive "*")
   (insert 181)
)

(defun insert-s-acute ()
   (interactive "*")
   (insert 182)
)

(defun insert-caron ()
   (interactive "*")
   (insert 183)
)

(defun insert-cedilla ()
   (interactive "*")
   (insert 184)
)

(defun insert-s-caron ()
   (interactive "*")
   (insert 185)
)

(defun insert-s-cedilla ()
   (interactive "*")
   (insert 186)
)

(defun insert-t-caron ()
   (interactive "*")
   (insert 187)
)

(defun insert-z-acute ()
   (interactive "*")
   (insert 188)
)

(defun insert-double-acute ()
   (interactive "*")
   (insert 189)
)

(defun insert-z-caron ()
   (interactive "*")
   (insert 190)
)

(defun insert-z-dot-above ()
   (interactive "*")
   (insert 191)
)

(defun insert-R-acute ()
   (interactive "*")
   (insert 192)
)

(defun insert-A-acute ()
   (interactive "*")
   (insert 193)
)

(defun insert-A-circumflex ()
   (interactive "*")
   (insert 194)
)

(defun insert-A-breve ()
   (interactive "*")
   (insert 195)
)

(defun insert-A-diaeresis ()
   (interactive "*")
   (insert 196)
)

(defun insert-L-acute ()
   (interactive "*")
   (insert 197)
)

(defun insert-C-acute ()
   (interactive "*")
   (insert 198)
)

(defun insert-C-cedilla ()
   (interactive "*")
   (insert 199)
)

(defun insert-C-caron ()
   (interactive "*")
   (insert 200)
)

(defun insert-E-acute ()
   (interactive "*")
   (insert 201)
)

(defun insert-E-ogonek ()
   (interactive "*")
   (insert 202)
)

(defun insert-E-diaeresis ()
   (interactive "*")
   (insert 203)
)

(defun insert-E-caron ()
   (interactive "*")
   (insert 204)
)

(defun insert-I-acute ()
   (interactive "*")
   (insert 205)
)

(defun insert-I-circumflex ()
   (interactive "*")
   (insert 206)
)

(defun insert-D-caron ()
   (interactive "*")
   (insert 207)
)

(defun insert-D-stroke ()
   (interactive "*")
   (insert 208)
)

(defun insert-N-acute ()
   (interactive "*")
   (insert 209)
)

(defun insert-N-caron ()
   (interactive "*")
   (insert 210)
)

(defun insert-O-acute ()
   (interactive "*")
   (insert 211)
)

(defun insert-O-circumflex ()
   (interactive "*")
   (insert 212)
)

(defun insert-O-double-acute ()
   (interactive "*")
   (insert 213)
)

(defun insert-O-diaeresis ()
   (interactive "*")
   (insert 214)
)

(defun insert-multiplication-sign ()
   (interactive "*")
   (insert 215)
)

(defun insert-R-caron ()
   (interactive "*")
   (insert 216)
)

(defun insert-U-ring-above ()
   (interactive "*")
   (insert 217)
)

(defun insert-U-acute ()
   (interactive "*")
   (insert 218)
)

(defun insert-U-double-acute ()
   (interactive "*")
   (insert 219)
)

(defun insert-U-diaeresis ()
   (interactive "*")
   (insert 220)
)

(defun insert-Y-acute ()
   (interactive "*")
   (insert 221)
)

(defun insert-T-cedilla ()
   (interactive "*")
   (insert 222)
)

(defun insert-sharp-s ()
   (interactive "*")
   (insert 223)
)

(defun insert-r-acute ()
   (interactive "*")
   (insert 224)
)

(defun insert-a-acute ()
   (interactive "*")
   (insert 225)
)

(defun insert-a-circumflex ()
   (interactive "*")
   (insert 226)
)

(defun insert-a-breve ()
   (interactive "*")
   (insert 227)
)

(defun insert-a-diaeresis ()
   (interactive "*")
   (insert 228)
)

(defun insert-l-acute ()
   (interactive "*")
   (insert 229)
)

(defun insert-c-acute ()
   (interactive "*")
   (insert 230)
)

(defun insert-c-cedilla ()
   (interactive "*")
   (insert 231)
)

(defun insert-c-caron ()
   (interactive "*")
   (insert 232)
)

(defun insert-e-acute ()
   (interactive "*")
   (insert 233)
)

(defun insert-e-ogonek ()
   (interactive "*")
   (insert 234)
)

(defun insert-e-diaeresis ()
   (interactive "*")
   (insert 235)
)

(defun insert-e-caron ()
   (interactive "*")
   (insert 236)
)

(defun insert-i-acute ()
   (interactive "*")
   (insert 237)
)

(defun insert-i-circumflex ()
   (interactive "*")
   (insert 238)
)

(defun insert-d-caron ()
   (interactive "*")
   (insert 239)
)

(defun insert-d-stroke ()
   (interactive "*")
   (insert 240)
)

(defun insert-n-acute ()
   (interactive "*")
   (insert 241)
)

(defun insert-n-caron ()
   (interactive "*")
   (insert 242)
)

(defun insert-o-acute ()
   (interactive "*")
   (insert 243)
)

(defun insert-o-circumflex ()
   (interactive "*")
   (insert 244)
)

(defun insert-o-double-acute ()
   (interactive "*")
   (insert 245)
)

(defun insert-o-diaeresis ()
   (interactive "*")
   (insert 246)
)

(defun insert-division-sign ()
   (interactive "*")
   (insert 247)
)

(defun insert-r-caron ()
   (interactive "*")
   (insert 248)
)

(defun insert-u-ring-above ()
   (interactive "*")
   (insert 249)
)

(defun insert-u-acute ()
   (interactive "*")
   (insert 250)
)

(defun insert-u-double-acute ()
   (interactive "*")
   (insert 251)
)

(defun insert-u-diaeresis ()
   (interactive "*")
   (insert 252)
)

(defun insert-y-acute ()
   (interactive "*")
   (insert 253)
)

(defun insert-t-cedilla ()
   (interactive "*")
   (insert 254)
)

(defun insert-dot-above ()
   (interactive "*")
   (insert 255)
)

(defvar dead-acute-map nil "Keymap for dead acute accent.")
(setq dead-acute-map (make-sparse-keymap))
(define-key dead-acute-map "A" 'insert-A-acute)
(define-key dead-acute-map "E" 'insert-E-acute)
(define-key dead-acute-map "I" 'insert-I-acute)
(define-key dead-acute-map "O" 'insert-O-acute)
(define-key dead-acute-map "U" 'insert-U-acute)
(define-key dead-acute-map "Y" 'insert-Y-acute)
(define-key dead-acute-map "R" 'insert-R-acute)
(define-key dead-acute-map "L" 'insert-L-acute)
(define-key dead-acute-map "C" 'insert-C-acute)
(define-key dead-acute-map "N" 'insert-N-acute)
(define-key dead-acute-map "S" 'insert-S-acute)
(define-key dead-acute-map "Z" 'insert-Z-acute)
(define-key dead-acute-map "a" 'insert-a-acute)
(define-key dead-acute-map "e" 'insert-e-acute)
(define-key dead-acute-map "i" 'insert-i-acute)
(define-key dead-acute-map "o" 'insert-o-acute)
(define-key dead-acute-map "u" 'insert-u-acute)
(define-key dead-acute-map "y" 'insert-y-acute)
(define-key dead-acute-map "r" 'insert-r-acute)
(define-key dead-acute-map "l" 'insert-l-acute)
(define-key dead-acute-map "c" 'insert-c-acute)
(define-key dead-acute-map "n" 'insert-n-acute)
(define-key dead-acute-map "s" 'insert-s-acute)
(define-key dead-acute-map "z" 'insert-z-acute)
(define-key dead-acute-map "=" 'self-insert-command)
(define-key dead-acute-map "[" 'self-insert-command)
(define-key dead-acute-map ";" 'self-insert-command)
(define-key dead-acute-map "1" 'self-insert-command)
(define-key dead-acute-map "2" 'self-insert-command)
(define-key dead-acute-map "3" 'self-insert-command)
(define-key dead-acute-map "4" 'self-insert-command)
(define-key dead-acute-map "5" 'self-insert-command)
(define-key dead-acute-map "6" 'self-insert-command)
(define-key dead-acute-map "7" 'self-insert-command)
(define-key dead-acute-map "8" 'self-insert-command)
(define-key dead-acute-map "9" 'self-insert-command)
(define-key dead-acute-map "0" 'self-insert-command)

(defvar dead-caron-map nil "Keymap for dead caron accent.")
(setq dead-caron-map (make-sparse-keymap))
(define-key dead-caron-map "Z" 'insert-Z-caron)
(define-key dead-caron-map "S" 'insert-S-caron)
(define-key dead-caron-map "C" 'insert-C-caron)
(define-key dead-caron-map "R" 'insert-R-caron)
(define-key dead-caron-map "D" 'insert-D-caron)
(define-key dead-caron-map "T" 'insert-T-caron)
(define-key dead-caron-map "N" 'insert-N-caron)
(define-key dead-caron-map "E" 'insert-E-caron)
(define-key dead-caron-map "L" 'insert-L-caron)
(define-key dead-caron-map "A" 'insert-A-breve)
(define-key dead-caron-map "O" 'insert-O-circumflex)
(define-key dead-caron-map "U" 'insert-U-ring-above)
(define-key dead-caron-map "z" 'insert-z-caron) 
(define-key dead-caron-map "s" 'insert-s-caron)
(define-key dead-caron-map "c" 'insert-c-caron)
(define-key dead-caron-map "r" 'insert-r-caron)
(define-key dead-caron-map "d" 'insert-d-caron)
(define-key dead-caron-map "t" 'insert-t-caron)
(define-key dead-caron-map "n" 'insert-n-caron)
(define-key dead-caron-map "e" 'insert-e-caron)
(define-key dead-caron-map "u" 'insert-u-ring-above)
(define-key dead-caron-map "l" 'insert-l-caron)
(define-key dead-caron-map "a" 'insert-a-breve)
(define-key dead-caron-map "o" 'insert-o-circumflex)
(define-key dead-caron-map "u" 'insert-u-ring-above)
(define-key dead-caron-map "+" 'self-insert-command)
(define-key dead-caron-map "[" 'self-insert-command)
(define-key dead-caron-map ";" 'self-insert-command)
(define-key dead-caron-map "1" 'self-insert-command)
(define-key dead-caron-map "2" 'self-insert-command)
(define-key dead-caron-map "3" 'self-insert-command)
(define-key dead-caron-map "4" 'self-insert-command)
(define-key dead-caron-map "5" 'self-insert-command)
(define-key dead-caron-map "6" 'self-insert-command)
(define-key dead-caron-map "7" 'self-insert-command)
(define-key dead-caron-map "8" 'self-insert-command)
(define-key dead-caron-map "9" 'self-insert-command)
(define-key dead-caron-map "0" 'self-insert-command)

(defvar dead-diaeresis-map nil "Keymap for dead diaeresis (umlaut) accent.")
(setq dead-diaeresis-map (make-sparse-keymap))
(define-key dead-diaeresis-map "a" 'insert-a-diaeresis)
(define-key dead-diaeresis-map "o" 'insert-o-diaeresis)
(define-key dead-diaeresis-map "u" 'insert-u-diaeresis)
(define-key dead-diaeresis-map "A" 'insert-A-diaeresis)
(define-key dead-diaeresis-map "O" 'insert-O-diaeresis)
(define-key dead-diaeresis-map "U" 'insert-U-diaeresis)
(define-key esc-map "\"" dead-diaeresis-map)

(defvar dead-ss-map nil "Keymap for dead ss (german sharp s prefix).")
(setq dead-ss-map (make-sparse-keymap))
(define-key dead-ss-map "s" 'insert-sharp-s)
(define-key esc-map "s" dead-ss-map)

(defvar dead-cedilla-map nil "Keymap for dead cedilla accent.")
(setq dead-cedilla-map (make-sparse-keymap))
(define-key dead-cedilla-map "c" 'insert-c-cedilla)
(define-key dead-cedilla-map "C" 'insert-C-cedilla)
(define-key dead-cedilla-map "t" 'insert-t-cedilla)
(define-key dead-cedilla-map "T" 'insert-T-cedilla)
(define-key dead-cedilla-map "a" 'insert-a-ogonek)
(define-key dead-cedilla-map "A" 'insert-A-ogonek)
(define-key esc-map "," dead-cedilla-map)

(defvar old-local-map nil "Klvesnice, ke kter se m vrtit po vypnut esk")

(defun load-cs-keyboard ()
   "Install Czech/Slovak accented letters on the top row
of the standard AT keyboard and dead keys for acute and
caron accents on = and +, respectively."
   (interactive "*")
   (local-set-key [pause] 'load-cs-keyboard)
   (setq old-local-map (copy-keymap (current-local-map)))
   (local-set-key [pause] 'unload-cs-keyboard)
   (local-set-key "z" 'insert-y)
   (local-set-key "Z" 'insert-Y)
   (local-set-key "y" 'insert-z)
   (local-set-key "Y" 'insert-Z)
   (local-set-key "`" 'insert-semicolon)
   (local-set-key "\M-`" 'insert-reverse-single-quote)
   (local-set-key "1" 'insert-plus)
   (local-set-key "!" 'insert-one)
   (local-set-key "\M-1" 'insert-exclamation)
   (local-set-key "\M-!" 'insert-exclamation)
   (local-set-key "2" 'insert-e-caron)
   (local-set-key "@" 'insert-two)
   (local-set-key "\M-2" 'insert-at)
   (local-set-key "\M-@" 'insert-at)
   (local-set-key "3" 'insert-s-caron)
   (local-set-key "#" 'insert-three)
   (local-set-key "\M-3" 'insert-channel)
   (local-set-key "\M-#" 'insert-channel)
   (local-set-key "4" 'insert-c-caron)
   (local-set-key "$" 'insert-four)
   (local-set-key "\M-4" 'insert-dollar)
   (local-set-key "\M-$" 'insert-dollar)
   (local-set-key "5" 'insert-r-caron)
   (local-set-key "%" 'insert-five)
   (local-set-key "\M-5" 'insert-percent)
   (local-set-key "\M-%" 'insert-percent)
   (local-set-key "6" 'insert-z-caron)
   (local-set-key "^" 'insert-six)
   (local-set-key "\M-6" 'insert-circumflex)
   (local-set-key "\M-^" 'insert-circimflex)
   (local-set-key "7" 'insert-y-acute)
   (local-set-key "&" 'insert-seven)
   (local-set-key "\M-7" 'insert-commercial-at)
   (local-set-key "\M-&" 'insert-commercial-at)
   (local-set-key "8" 'insert-a-acute)
   (local-set-key "*" 'insert-eight)
   (local-set-key "\M-8" 'insert-asterisk)
   (local-set-key "\M-*" 'insert-asterisk)
   (local-set-key "9" 'insert-i-acute)
   (local-set-key "(" 'insert-nine)
   (local-set-key "\M-9" 'insert-lparen)
   (local-set-key "\M-(" 'insert-lparen)
   (local-set-key "0" 'insert-e-acute)
   (local-set-key ")" 'insert-zero)
   (local-set-key "\M-0" 'insert-rparen)
   (local-set-key "\M-)" 'insert-rparen)
   (local-set-key "-" 'insert-equal-to)
   (local-set-key "_" 'insert-percent)
   (local-set-key "\M--" 'insert-hyphen)
   (local-set-key "\M-_" 'insert-underscore)
   (local-set-key "=" dead-acute-map)
   (local-set-key "+" dead-caron-map)
   (local-set-key "\M-=" 'insert-equal-to)
   (local-set-key "\M-+" 'insert-plus)
   (local-set-key "[" 'insert-u-acute)
   (local-set-key "{" 'insert-slash)
   (local-set-key "\M-[" 'insert-lbracket)
   (local-set-key "\M-{" 'insert-lbrace)
   (local-set-key "]" 'insert-rparen)
   (local-set-key "}" 'insert-lparen)
   (local-set-key "\M-]" 'insert-rbracket)
   (local-set-key "\M-}" 'insert-rbrace)
   (local-set-key ";" 'insert-u-ring-above)
   (local-set-key ":" 'insert-exclamation)
   (local-set-key "\M-;" 'insert-semicolon)
   (local-set-key "\M-:" 'insert-colon)
   (local-set-key "<" 'insert-question)
   (local-set-key ">" 'insert-colon)
   (local-set-key "\M-<" 'insert-less-than)
   (local-set-key "\M->" 'insert-greater-than)
   (local-set-key "/" 'insert-hyphen)
   (local-set-key "?" 'insert-underscore)
   (local-set-key "\M-/" 'insert-slash)
   (local-set-key "\M-?" 'insert-question)
   (local-set-key "\M-q" 'insert-backslash)
   (local-set-key "\M-w" 'insert-vertical-bar)
;  To be sure, I define these keys again because some modes redefine them back.
   (local-set-key [backspace] 'backward-delete-char-untabify)
   (local-set-key [delete] 'delete-char)
   (local-set-key [home] 'beginning-of-line)
   (local-set-key [end] 'end-of-line)
)

(defun unload-cs-keyboard ()
   "Uninstall Czech/Slovak keyboard."
   (interactive "*")
   (use-local-map old-local-map)
)

(provide 'isol2-insert)

;;; isol2-insert.el ends here



